/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <E/sm_btree.h>

// a wrapper for E btree classes to slightly simplify the interface

dbclass IntBtIndex {
private:
    btree<int> index;

public:
    void insert(int val, dbvoid* ref);  // insert (value, ref) pair
    dbvoid* lookup(int val); // look up val, returning ref to object
    dbvoid* remove(int val); // delete val, returning ref to object
    // bulk load begin and end routines
    BeginBulkLoad(int runsize=BLKLD_RunSize) { return index.BeginBulkLoad(runsize);};
    EndBulkLoad()   { return index.EndBulkLoad(); };
};
