
#include <stdio.h>
#include <E/sm_btree.h>
#include <E/collection.h>
#include <E/dbStrings.h>
persistent  btree<int> * test_btree;
persistent collection<dbchar> strspace;
void add_btree_node(int val)
{
   // new test: add 2 strings, indexed by each val 
   char buf[200];
   dbchar *p1;
   dbchar *p2;
   sprintf(buf,"%d.a",val);
   p1 = new(strspace) dbchar[strlen(buf)+1];
   strcpy(p1,buf);
  test_btree->insert(val,p1);
  if (val %10000 ==  0)
	printf("inserted key %d\n",val);
}




int num_vals = 3;
persistent dbint p_numvals;
#include <stdio.h>
main(int argc, char *argv[])
{
  int i;

  fprintf(stderr, "Turning off logging\n");
  sm_SetLogLevel(LOG_SPACE, 0, 0);
  E_BeginTransaction();
  if (argc >1)
  {
    sscanf(argv[1],"%d",&num_vals);
    p_numvals = num_vals;
    printf("loading %d values\n",num_vals);
    test_btree = new(strspace) btree<int>;
    if (test_btree->BeginBulkLoad())
	printf("BeginBulkLoad error: %s\n",sm_Error(sm_errno));
    if (num_vals > 0)
    {
      for (i=0;i<num_vals;i++)
	  add_btree_node(i+1);
    }
    printf("beginning EndBulkLoad\n");
    if (test_btree->EndBulkLoad())
	printf("EndBulkLoad error: %s\n",sm_Error(sm_errno));
    E_CommitTransaction();
    return 0;
  }
  else
  {
    num_vals = p_numvals;
  }
  // first, try a singl point retrieve
  srandom(1);
  for (int loopi=0;loopi<10;loopi++)
  
  {
    int i = (int) (random() % num_vals) + 1;
    btree_retrieve<int> retr_1(*test_btree,i);
    printf("retrieving keys for %d\n",i);
    for (retr_1.next(); !retr_1.eof; retr_1.next()) 
    {
      char buf[200];
      strcpy(buf,(dbchar *)retr_1.cur_elem);
      printf("%d: %s\n",retr_1.cur_keyval,buf);


    }
  }
  E_CommitTransaction();
}

